<?php
/** ensure this file is being included by a parent file */
if ( ! ( defined( '_VALID_CB' ) || defined( '_JEXEC' ) || defined( '_VALID_MOS' ) ) ) { die( 'Direct Access to this location is not allowed.' ); }
class getDMSTab  extends cbTabHandler {
	/**
	* Constructor
	*/
	var $_subDocIds = array() ;
	var $__docIds = array() ;
	/**
	 * Get order history tab
	 *
	 */	
	function getDMSTab() {
		$this->cbTabHandler();
	}
	/**
	 * Order history of a user
	 *
	 * @param object $tab
	 * @param object $user
	 * @param int $ui
	 */
	function getDisplayTab($tab,$user,$ui) {
		require_once (JPATH_ROOT.DS.'components'.DS.'com_dms'.DS.'helper'.DS.'helper.php');		
		$db = & JFactory::getDBO() ;
		$currentUser = & JFactory::getUser() ;
		if ($currentUser->id != $user->id)
			return ;							
		$docs = getDMSTab::getDownloadableDocs(false) ;
		$arrDocs = array_merge($docs['docs'], $docs['expired']) ;				 
		$where = array() ;		
		$where[] = ' a.published = 1 ';
		$where[] = ' a.id IN ( '.implode(',', $arrDocs) . ')' ;		
		$where 		= ( count( $where ) ? ' WHERE '. implode( ' AND ', $where ) : '' );		
		$sql = 'SELECT COUNT(*) FROM #__dms_documents AS a '. $where;	
		$db->setQuery($sql) ;
		$total = $db->loadResult();				
		$params = $this->params ;					
		$numberRecords = $params->get('number_records', 10);		
		$pagingParams = $this->_getPaging(array(),array("entries_"));
		if ($pagingParams["entries_limitstart"] === null) $pagingParams["entries_limitstart"] = "0";
		if ($numberRecords > $total) $pagingParams["entries_limitstart"] = "0";		
		$sql=" SELECT a.* FROM #__dms_documents AS a "
			. $where
			. " Order by a.id DESC "			
			. "\n LIMIT ".($pagingParams["entries_limitstart"]?$pagingParams["entries_limitstart"]:"0").",".$numberRecords;
		;
		$db->setQuery($sql) ;		
		$rows = $db->loadObjectList();		
		//Get currency symbol
		$sql = 'SELECT config_value FROM #__jd_configs WHERE config_key="currency_symbol"';
		$db->setQuery($sql);
		$currencySymbol = $db->loadResult();	
		ob_start();
		$this->_drawOrderHistory($rows, $currencySymbol, $pagingParams, $numberRecords, $total, $docs['docs']);
		$return = ob_get_contents();
		ob_end_clean();
		return $return;
	}

	/**
	 * Draw the output for donation history
	 *
	 * @param array $rows
	 */
	function _drawOrderHistory($rows , $symbol, $pagingParams, $numebrDonors, $total, $docs) {			
		DMSHelper::loadLanguage();
		$Itemid = DMSHelper::getItemid();				
		if (count($rows)) {
		?>
			<table width="100%">
				<tr>
					<td class="sectiontableheader" width="10%">
						<?php echo JText::_('DMS_NO'); ?>
					</td>
					<td class="sectiontableheader">
						<?php echo JText::_('DMS_DOCUMENT'); ?>
					</td>
					<td class="sectiontableheader" width="15%">
						<?php echo JText::_('DMS_PRICE').'('.$symbol.')'; ?>
					</td>
					<td class="sectiontableheader" width="20%">
						<?php echo JText::_('DMS_RESTRICTION'); ?>
					</td>
					<td class="sectiontableheader" width="15%" style="text-align: center;">
						<?php echo JText::_('DMS_DOWNLOAD'); ?>
					</td>					
				</tr>
				<?php
					$tabs = array('sectiontableentry1', 'sectiontableentry1');					
					$k = 0 ;			
					for ($i = 0 , $n = count($rows) ; $i < $n; $i++) {
						$item = $rows[$i] ;
						$url = JRoute::_('index.php?option=com_dms&task=view_document&category_id='.$item->category_id.'&id='.$item->id.'&Itemid='.$Itemid);
						$tab = $tabs[$k] ;						
					?>
						<tr class="<?php echo $tab; ?>">
							<td>
								<?php echo $i + 1 ; ?>
							</td>					
							<td>
								<a href="<?php echo $url; ?>"><?php echo $item->title; ?></a>
							</td>		
							<td>
								<?php echo number_format($item->price, 2); ?>
							</td>		
							<td>
								<?php
									if ($item->prevent_download_type == 1) {
										$restriction = $item->number_downloads.JText::_('DMS_DOWNLOADS') ;
									} elseif ($item->prevent_download_type == 2) {
										$restriction = $item->number_days . JText::_('DMS_DAYS');	
									} else {
										$restriction = JText::_('DMS_LIFETIME') ;
									}
								?>
								<strong><?php echo $restriction ; ?></strong>
							</td>		
							<td align="center">
								<?php
									if (in_array($item->id, $docs)) {
										$downloadLink = 'index.php?option=com_dms&task=doc_download&id='.$item->id.'&Itemid='.$Itemid ;
									?>
										<a href="<?php echo $downloadLink; ?>"><strong><?php echo JText::_('DMS_DOWNLOAD');?></strong></a>
									<?php		
									} else {
										echo '<span class="required">'.JText::_('DMS_EXPIRED').'</span>';
									}	
								?>								
							</td>
						</tr>
					<?php				
						$k = 1 - $k ;				
					}						
					if ($total > $numebrDonors) {
					?>
						<tr>
							<td colspan="5">
								<div align="center"><?php echo $this->_writePaging($pagingParams ,"entries_", $numebrDonors, $total);  ?></div>
							</td>
						</tr>
					<?php	
					}
				?>												
			</table>
		<?php	
		}		
	}
		
	function getDownloadableDocs($includeFree = true) {
		$db = & JFactory::getDBO();
		$user = & JFactory::getUser() ;
		$userId = & $user->get('id');
		$aid = $user->get('aid') ;
		if (version_compare(JVERSION, '1.6.0', 'ge'))
			$viewLevels = $user->getAuthorisedViewLevels() ;
		$email = $user->email ;
		$downloadFreeDoc = DMSHelper::getConfigValue('download_free_doc');
		static $docs = array() ;
		static $expired = array() ;
		static $loaded ;
		if (!$loaded) {
			//Get a;; free documents
			if (version_compare(JVERSION, '1.6.0', 'ge')) {
				if ((in_array($downloadFreeDoc, $viewLevels)) && $includeFree) {
					$sql = 'SELECT id FROM #__dms_documents WHERE published = 1 AND price = 0';
					$db->setQuery($sql) ;
					$rows = $db->loadObjectList();
					for ($i = 0 , $n = count($rows) ; $i < $n ; $i++) {
						$row = $rows[$i] ;
						$docs[] = $row->id ;
					}
				}
			} else {
				if (($downloadFreeDoc <= $aid) && $includeFree) {
					$sql = 'SELECT id FROM #__dms_documents WHERE published = 1 AND price = 0';
					$db->setQuery($sql) ;
					$rows = $db->loadObjectList();
					for ($i = 0 , $n = count($rows) ; $i < $n ; $i++) {
						$row = $rows[$i] ;
						$docs[] = $row->id ;
					}
				}
			}
			//Get all documents which this user purchased
			if ($userId) {
				$sql = 'SELECT c.id, DATEDIFF(NOW(), a.payment_date) AS days_diffirent, b.downloaded,  c.prevent_download_type, c.number_days, c.number_downloads FROM #__dms_orders AS a '
				. ' INNER JOIN #__dms_order_item AS b '
				. ' ON a.id = b.order_id '
				. ' INNER JOIN #__dms_documents AS c '
				. ' ON b.document_id = c.id '
				. " WHERE (a.user_id = $userId OR a.email='$email')"
				. ' AND a.published = 1 '
				;
				$db->setQuery($sql) ;
				$rows = $db->loadObjectList();
				for ($i = 0 , $n = count($rows) ; $i < $n ; $i++) {
				$row = $rows[$i] ;
				if ($row->prevent_download_type == 0) {
				$downloadable = true ;
				} elseif ($row->prevent_download_type == 1 && ($row->number_downloads > $row->downloaded)) {
				$downloadable = true ;
				} else if ($row->prevent_download_type == 2 && ($row->number_days >= $row->days_diffirent)) {
				$downloadable = true ;
				} else {
				$downloadable = false ;
				}
				if ($downloadable)
					$docs[] = $row->id ;
					else
					$expired[] = $row->id ;
			}
			}
			$loaded = true ;
			}
			return array('docs'=> $docs, 'expired' => $expired) ;
	}	
}
?>
